jQuery(document).ready(function() {

	// NO-OP if not in editor
	if (!$('body').hasClass('in-editor')) {
		return;
	}

    var editorVueNode = window.top.$('#page-frame').parent()[0].__vue__;
    window.top.$vm = editorVueNode;
    
    // Add VueX-mutation to modify properties on a non-current page
    editorVueNode.$store._mutations['UPDATE_RENDER_OBJECT_ON_PAGE'] = function(state, targetObject, dataSrcPath, assetsPath) {
        
        //console.log('>>> UPDATE_RENDER_OBJECT_ON_PAGE <<<');
        //console.log('--- this:', this);
        //console.log('--- state:', state);
        //console.log('--- a:', targetObject);
        //console.log('--- b:', dataSrcPath);
        //console.log('--- c:', assetsPath);

        var _ = window.top._;

        _.set(targetObject, dataSrcPath, assetsPath);

        var targetPageId = targetObject.id;
        var pageList = state.data.pages;
        
        //console.log('--- targetPageId:', targetPageId);
        //console.log('--- set real page:', pageList);
        
        var didChange = false;
        for (var i = 0, n = pageList.length; i < n; i++) {
            var page = pageList[i];
            //console.log('--- page.id:', page.id);
            if (page.id == targetPageId) {
                //console.log('--- FOUND REAL PAGE:', page);
                var dataPath = dataSrcPath.replace(/^page\./, "data.");
                _.set(page, dataPath, assetsPath);
                didChange = true;
                break;
            }
        }
    }

    // Patch submitImageModal-function to use data-tidy-src-target
    var _submitImageModal = editorVueNode.submitImageModal;
    editorVueNode.submitImageModal = function(modalResult) {
    
        //console.log('>>> editorVueNode.submitImageModal::this:', this);
        //console.log('--- submitImageModal::modalResult:', modalResult);
        //console.log('---');
        
        var _ = window.top._;
        var scope = editorVueNode;
        var dataTarget = scope.imageModalElement.attr('data-tidy-src-target');

        if (dataTarget) {

            var dataSrcPath = scope.imageModalElement.attr("data-tidy-src-target-path");
            var dataAltPath = scope.imageModalElement.attr("data-tidy-alt-path");
            
            var oldValue;
            if (dataSrcPath) {

                // Make sure we are targeting a valid target and not something evil...
                var isValidProperty = Boolean(dataTarget.match(/^children\[[0-9]+\]/));
                //console.log('--- dataTarget:', dataTarget);
                //console.log('--- dataSrcPath:', dataSrcPath);
                //console.log('--- isValidProperty:', isValidProperty);
                
                if (isValidProperty) {

                    var targetObject = eval('scope.renderObject.' + dataTarget);
                    
                    //console.log('--- targetObject:', targetObject);

                    if (targetObject) {
                        oldValue = _.get(targetObject, dataSrcPath);
                        if (oldValue != modalResult.assetsPath) {
                            scope.$store.dispatch('UPDATE_RENDER_OBJECT_ON_PAGE', targetObject, dataSrcPath, modalResult.assetsPath);
                            // Fake-update to trigger updateStateChanges
                            scope.$store.dispatch('UPDATE_RENDER_OBJECT', 'meta.title', scope.renderObject.meta.title);

                        }
                        scope.imageModalElement.attr("src", modalResult.assetsPath);
                    }
                }
            }
    
            /*
            if (dataAltPath) {
                oldValue = _.get(scope.renderObject, dataAltPath);
                if (oldValue != t.altText) {

                    //e.dispatch("UPDATE_RENDER_OBJECT", dataAltPath, t.altText),

                    try {
                        var o = e.ui.pages.current;
                        r.updatePageByRenderObjectValue(e, o, t, n),
                        _.set(e.ui.pages.renderObject, t, n),
                        r.updateStateChanges(e)
                    } catch (a) {
                        console.warn(a)
                    }
                    
                    scope.imageModalElement.attr("alt", t.altText);
                }
            }
            */
         
        } else {

            _submitImageModal.call(editorVueNode, modalResult);

        }
    }
    
    var $imgs = $('img[data-tidy-src-target]');
    $imgs.each(function() {
        var $img = $(this);
        $img.click(function(e) {
            e.preventDefault();
            e.stopPropagation();
            editorVueNode.openImageModal($img);
        });
    });
});

